GLOBAL.setmetatable(env,{__index=function(t,k) return GLOBAL.rawget(GLOBAL,k) end})

--[[local function HookComponent(name, fn)
    fn(require ("components/"..name))
end

HookComponent("inventoryitem_replica", function(InventoryItem)
    local Old_GetWalkSpeedMult = InventoryItem.GetWalkSpeedMult
    InventoryItem.GetWalkSpeedMult = function(self, ...)
        local Speed_Mult = Old_GetWalkSpeedMult(self, ...)
        if ThePlayer and ThePlayer:HasTag("skd") and Speed_Mult < 1 then
            return 1   
        end   
        return Old_GetWalkSpeedMult(self, ...)
    end
end)

AddComponentPostInit("equippable", function(self)
    local _OldGetWalkSpeedMult = self.GetWalkSpeedMult
    function self:GetWalkSpeedMult(...)
        local owner = self.inst.components.inventoryitem and self.inst.components.inventoryitem.owner or nil
        if owner and owner:HasTag("skd") and self.walkspeedmult and self.walkspeedmult < 1 then
            return 1
        end 

        return _OldGetWalkSpeedMult(self, ...)
    end    
end)]]

AddPlayerPostInit(function(inst)
    --[[if not TheWorld.ismastersim then
        return inst
    end]]

    if inst.components.monster_num == nil then
        inst:AddComponent("monster_num")
        inst.components.monster_num:SetMax(10)
    end    
end)      

AddPrefabPostInit("skd", function(inst)
    --[[if not TheWorld.ismastersim then
        return inst
    end]]

    local _getHealth = inst.components.health.DoDelta
    inst.components.health.DoDelta = function(self, amount, overtime, cause, ignore_invincible, afflicter, ignore_absorb)
        if (self.currenthealth + amount) <= 0 --[[and inst.components.inventory:Has("skd_new_item1", 1)]] then 
            local item = inst.components.inventory:FindItem(function(item) return item.prefab == "skd_new_item1" end) 
            if item then
                amount = 0
                self.currenthealth = self.maxhealth * 0.4 

                local fx = SpawnPrefab("skd_new_item1_fx") --护盾特效
                fx.entity:SetParent(inst.entity)

                item.components.container:DropEverything()
                item:Remove()
            end 
        end     
                                     
        return _getHealth(self, amount, overtime, cause, ignore_invincible, afflicter, ignore_absorb) 
    end  
end)   

--[[AddPrefabPostInit("crawlinghorror", function(inst)
    if not TheWorld.ismastersim then
        return inst
    end

    inst.find_skd = inst:DoTaskInTime(0, function(inst) 
        if inst.spawnedforplayer and inst.spawnedforplayer:IsValid() and inst.spawnedforplayer.prefab == "skd" then
            inst.components.health:SetMaxHealth(inst.components.health.maxhealth * 2)
            inst.components.combat:SetDefaultDamage(inst.components.combat.defaultdamage * 2)            
        end    
        if inst.find_skd then
            inst.find_skd:Cancel()
            inst.find_skd = nil
        end    
    end)
end)         

AddPrefabPostInit("terrorbeak", function(inst)
    if not TheWorld.ismastersim then
        return inst
    end

    inst.find_skd = inst:DoTaskInTime(0, function(inst) 
        if inst.spawnedforplayer and inst.spawnedforplayer:IsValid() and inst.spawnedforplayer.prefab == "skd" then
            inst.components.health:SetMaxHealth(inst.components.health.maxhealth * 2)
            inst.components.combat:SetDefaultDamage(inst.components.combat.defaultdamage * 2)            
        end       
        if inst.find_skd then
            inst.find_skd:Cancel()
            inst.find_skd = nil
        end    
    end)
end)   ]]

--[[local containers = require "containers"
local params = containers.params
params.skd_new_item1 =
{
    widget =
    {
        slotpos =
        {
            Vector3(0, 64 + 8, 0),
            Vector3(0, 0, 0),
            Vector3(0, -(64 + 8), 0),
        },
        animbank = "quagmire_ui_pot_1x3",
        animbuild = "quagmire_ui_pot_1x3",
        pos = Vector3(200, 0, 0),
        side_align_tip = 100,
    },
    type = "pack",
}

function params.skd_new_item1.itemtestfn(container, item, slot)
    if item and item:HasTag("weapon") then
        return true
    end

    return false
end

params.skd_new_item2 =
{
    widget =
    {
        slotpos =
        {
            Vector3(0, 64 + 8, 0),
            Vector3(0, 0, 0),
            Vector3(0, -(64 + 8), 0),
        },
        animbank = "quagmire_ui_pot_1x3",
        animbuild = "quagmire_ui_pot_1x3",
        pos = Vector3(200, 0, 0),
        side_align_tip = 100,
    },
    type = "pack",
}

-- 这段放最后
for k, v in pairs(params) do
    containers.MAXITEMSLOTS = math.max(containers.MAXITEMSLOTS,
                                       v.widget.slotpos ~= nil and
                                           #v.widget.slotpos or 0)
end
]]