local Monster_Num = Class(function(self, inst)
    self.inst = inst
    self.max = 10
    self.current = 0
end)

function Monster_Num:SetMax(amount)
    self.max = amount      
end

function Monster_Num:DoDelta(delta) 
    self.current = math.clamp(self.current + delta, 0, self.max)  --ThePlayer.components.monster_num:DoDelta(10)

    if self.current >= self.max and self.inst.components.health then
        self.current = self.current - self.max
        -- self.inst.components.health:DeltaPenalty(0.1)
    end    
end

function Monster_Num:OnSave()
    return
    {
        current = self.current,
        max = self.max,
    }
end

function Monster_Num:OnLoad(data)
    if data.current ~= nil then
        self.current = data.current
    end

    if data.max ~= nil then
        self.max = data.max
    end

	self:DoDelta(0)
end

return Monster_Num

