local assets =
{
	Asset("ANIM", "anim/skd_monster2_fx.zip"),
    Asset("ANIM", "anim/skd_monster4_fx.zip")
}

local function fx1()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    -- inst.entity:AddNetwork()
    inst.entity:AddAnimState()
    inst:AddTag("FX")
    inst.entity:SetCanSleep(false)

    inst.AnimState:SetBank("skd_monster2_fx")
    inst.AnimState:SetBuild("skd_monster2_fx")
    inst.AnimState:PlayAnimation("idle", true) 
    inst.AnimState:SetBloomEffectHandle("shaders/anim.ksh")

    inst.AnimState:SetFinalOffset(-1)
    inst.AnimState:SetOrientation( ANIM_ORIENTATION.OnGround )
    inst.AnimState:SetLayer( LAYER_BACKGROUND )
    inst.AnimState:SetSortOrder( 3 )
    --140/255, 239/255, 50/255, 1
    inst.AnimState:SetMultColour(50/255, 239/255, 255/255, 1)

    inst.Transform:SetScale(2, 2, 2)   

    -- inst.entity:SetPristine()

    -- if not TheWorld.ismastersim then
        -- return inst
    -- end

    inst.persists = false
    inst:ListenForEvent("animover", inst.Remove)

    return inst
end

local function fx2()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    -- inst.entity:AddNetwork()
    inst.entity:AddAnimState()
    inst:AddTag("FX")
    inst.entity:SetCanSleep(false)

    inst.AnimState:SetBank("skd_monster4_fx")
    inst.AnimState:SetBuild("skd_monster4_fx")
    inst.AnimState:PlayAnimation("idle", true) 
    inst.AnimState:SetBloomEffectHandle("shaders/anim.ksh")

    inst.AnimState:SetFinalOffset(-1)
    inst.AnimState:SetOrientation( ANIM_ORIENTATION.OnGround )
    inst.AnimState:SetLayer( LAYER_BACKGROUND )
    inst.AnimState:SetSortOrder( 3 )
    --140/255, 239/255, 50/255, 1
    inst.AnimState:SetMultColour(50/255, 239/255, 255/255, 1) 

    inst.Transform:SetScale(1, 1, 1) 

    -- inst.entity:SetPristine()

    -- if not TheWorld.ismastersim then
        -- return inst
    -- end

    inst.persists = false
    inst:ListenForEvent("animover", inst.Remove)

    return inst
end

return Prefab("skd_monster2_fx", fx1, assets),
       Prefab("skd_monster4_fx", fx2)